routes/web.php
<?php

use App\Http\Controllers\admin\CommonController;
use App\Http\Controllers\Admin\MarkController;
use App\Http\Controllers\Admin\StudentController;
use App\Http\Controllers\Admin\SubjectController;
use App\Http\Controllers\Admin\TeacherController;
use App\Http\Controllers\Admin\TermController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::prefix('admin')->group(function () {
    Route::group(['middleware' => 'auth:web'], function () {
        Route::resource('teacher', TeacherController::class);
        Route::get('delete/{route}/{id}', [CommonController::class, 'delete'])->name('delete');
        Route::resource('student', StudentController::class);
        Route::resource('subject', SubjectController::class);
        Route::resource('term', TermController::class);
        Route::resource('mark', MarkController::class);
    });
});

app/Models/Mark.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Mark extends Model
{
    use HasFactory;
}

app/Http/Controllers/Admin/MarkController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Mark;
use App\Models\MarkItem;
use App\Models\Student;
use App\Models\Subject;
use App\Models\Term;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Yajra\DataTables\Facades\DataTables;

class MarkController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if ($request->ajax()) {
            $data = Mark::select('marks.id', 'student_id', 'term_id', 'students.name', 'terms.name as term')
                ->leftjoin('students', 'students.id', 'marks.student_id')
                ->leftjoin('terms', 'terms.id', 'marks.term_id');
            $table =  DataTables::of($data)
                ->addIndexColumn()
                ->addColumn('action', function ($row) {
                    $button = '<button type="button" data-href="' . route('mark.edit', $row->id) . '" class="btn btn-xs btn-primary  edit_button" data-container=".modal_class"><i class="fa fa-edit"></i></button>&nbsp';
                    $button .= '<button data-href="' . route('delete', ['mark', $row->id]) . '" class="btn btn-xs btn-danger btn-modal"><i class="fa fa-trash"></i></button>';
                    return $button;
                });
            $subjects = Subject::get();
            $mark = 0;
            foreach ($subjects as $subject) {
                $table = $table->addColumn($subject->name, function ($row) use ($subject, $mark) {
                    if (MarkItem::where('subject_id', $subject->id)->where('mark_id', $row->id)->exists()) {
                        $mark = $mark + MarkItem::where('subject_id', $subject->id)->where('mark_id', $row->id)->first()['marks'];
                        return MarkItem::where('subject_id', $subject->id)->where('mark_id', $row->id)->first()['marks'];
                    } else {
                        return '-';
                    }
                    //return MarkItem::where('subject_id', $subject->id)->where('mark_id', $row->id)->first() ? MarkItem::where('subject_id', $subject->id)->where('mark_id', $row->id)->first()['marks'] : '-';
                });
            }
            $table = $table->addColumn('date', function ($row) {
                return date('M d, Y h:i A', strtotime($row->created_at));
            });
            $table = $table->addColumn('total', function ($row) {
                return MarkItem::where('mark_id', $row->id)->sum('marks');
            })

                ->filter(function ($instance) use ($request) {
                    if (!empty($request->get('search'))) {
                        $instance->where(function ($w) use ($request) {
                            $search = $request->get('search');
                            $w->Where('students.name', 'LIKE', "%$search%");
                        });
                    }
                })
                ->rawColumns(['status', 'action'])
                ->make(true);
            return $table;
        }
        $subjects = Subject::get();
        return view('admin.marks.index')->with(compact('subjects'));
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $students = Student::get();
        $terms = Term::get();
        $subjects = Subject::get();
        return view('admin.marks.create')->with(compact('students', 'terms', 'subjects'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if ($request->ajax()) {
            $rules = [
                'student_id'     => 'required',
                'term_id'     => 'required',
                'subject_id'     => 'required|array',
                'mark'     => 'required|array',
            ];
            $messages = [
                'student_id.required' => 'Student Required',
            ];
            $validator = Validator::make(request()->all(), $rules, $messages);
            if ($validator->fails()) {
                return response()->json(['status' => false, 'message' => $validator->errors()->first()]);
            }
            if (Mark::where('student_id', $request->student_id)->where('term_id', $request->term_id)->exists()) {
                return response()->json(['status' => false, 'message' => 'Data Already exist, Try Update!']);
            }
            try {
                DB::beginTransaction();
                $mark = new Mark();
                $mark->student_id      = $request->student_id;
                $mark->term_id      = $request->term_id;
                $mark->save();

                foreach ($request->subject_id as $key => $value) {
                    $mark_item = new MarkItem();
                    $mark_item->mark_id = $mark->id;
                    $mark_item->subject_id = $value;
                    $mark_item->marks = $request->mark[$key];
                    $mark_item->save();
                }
                DB::commit();
                return response()->json(['status' => true, 'message' => 'Successfully created']);
            } catch (\Exception $e) {
                DB::rollBack();
                return response()->json(['status' => false, 'message' => $e->getMessage()]);
            }
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $students = Student::get();
        $terms = Term::get();
        $subjects = Subject::get();
        $mark = Mark::where('id', $id)->first();
        foreach ($subjects as $v) {
            if (MarkItem::where('subject_id', $v->id)->where('mark_id', $id)->doesntExist()) {
                $item = new MarkItem();
                $item->mark_id = $id;
                $item->subject_id = $v->id;
                $item->marks = null;
                $item->save();
            }
        }
        $mark_items = MarkItem::where('mark_id', $id)->get();
        return view('admin.marks.edit')->with(compact('students', 'terms', 'subjects', 'mark', 'mark_items'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if (request()->ajax()) {
            $rules = [
                'student_id'     => 'required',
                'term_id'     => 'required',
                'mark_item'     => 'required|array',
                'mark'     => 'required|array',
            ];
            $messages = [
                'student_id.required' => 'Student Required',
            ];
            $validator = Validator::make(request()->all(), $rules, $messages);
            if ($validator->fails()) {
                return response()->json(['status' => false, 'message' => $validator->errors()->first()]);
            }
            try {
                if (Mark::where('id', '!=', $id)->where('student_id', $request->student_id)->where('term_id', $request->term_id)->exists()) {
                    return response()->json(['status' => false, 'message' => 'Data Already exist, Try Update!']);
                }
                DB::beginTransaction();
                $mark = Mark::findOrFail($id);
                $mark->student_id      = $request->student_id;
                $mark->term_id      = $request->term_id;
                $mark->save();

                foreach ($request->mark_item as $key => $value) {
                    $item = MarkItem::findOrFail($value);
                    $item->marks = $request->mark[$key];
                    $item->save();
                }
                DB::commit();
                return response()->json(['status' => true, 'message' => 'Successfully created']);
            } catch (\Exception $e) {
                DB::rollBack();
                return response()->json(['status' => false, 'message' => $e->getMessage()]);
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        if (request()->ajax()) {
            try {
                DB::beginTransaction();
                $term = Mark::findOrFail($id);
                $term->delete();
                MarkItem::where('mark_id', $id)->delete();
                DB::commit();
                return response()->json(['status' => true, 'message' => 'Successfully deleted']);
            } catch (\Exception $e) {
                DB::rollBack();
                return response()->json(['status' => false, 'message' => 'Something went Wrong!']);
            }
        }
    }
}

resources/views/admin/marks/create.blade.php
<div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
        <form method="post" action="{{route('mark.store')}}" accept-charset="UTF-8" id="createForm">
            @csrf
            <div class="modal-header">
                <h4 class="modal-title">ADD MARKS</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
            </div>
            <div class="modal-body">
                <div class="row">
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="name" class="control-label">MARKS:*</label>
                            <select class="form-control" required="" name="student_id">
                                <option value="">SELECT MARKS</option>
                                @foreach ($students as $item)
                                    <option value="{{$item->id}}">{{$item->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="name" class="control-label">TERM:*</label>
                            <select class="form-control" required="" name="term_id">
                                <option value="">SELECT TERM</option>
                                @foreach ($terms as $item)
                                    <option value="{{$item->id}}">{{$item->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th>SUBJECT</th>
                                    <th>MARKS</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($subjects as $item)
                                    <tr>
                                        <td>{{$item->name}}</td>
                                        <td>
                                            <input type="hidden" name="subject_id[]" value="{{$item->id}}">
                                            <input type="text" name="mark[]" class="form-control" required placeholder="Mark">
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
                
                



                
            <div class="modal-footer">
                <button type="submit" class="btn btn-success save_button">SAVE</button>
                <button type="button" class="btn btn-warning" data-dismiss="modal">CLOSE</button>
            </div>
        </form>
  </div><!-- /.modal-content -->
</div><!-- /.modal-dialog -->

resources/views/admin/marks/edit.blade.php
<div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
        <form method="post" action="{{route('mark.update',$mark->id)}}" accept-charset="UTF-8" id="edit_form">
            <input name="_method" type="hidden" value="PUT">
            @csrf
            <div class="modal-header">
                <h4 class="modal-title">ADD MARKS</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
            </div>
            <div class="modal-body">
                <div class="row">
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="name" class="control-label">MARKS:*</label>
                            <select class="form-control" required="" name="student_id">
                                <option value="">SELECT MARKS</option>
                                @foreach ($students as $item)
                                    <option value="{{$item->id}}" @if ($mark->student_id==$item->id) selected @endif>{{$item->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="name" class="control-label">TERM:*</label>
                            <select class="form-control" required="" name="term_id">
                                <option value="">SELECT TERM</option>
                                @foreach ($terms as $item)
                                    <option value="{{$item->id}}" @if ($mark->term_id==$item->id) selected @endif>{{$item->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th>SUBJECT</th>
                                    <th>MARKS</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($subjects as $key=>$item)
                                    <tr>
                                        <td>{{$item->name}}</td>
                                        <td>
                                            <input type="hidden" name="mark_item[]" value="{{$mark_items[$key]['id']}}">
                                            <input type="text" name="mark[]" value="{{$mark_items[$key]['marks']}}" class="form-control" required placeholder="Mark">
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
                
                



                
            <div class="modal-footer">
                <button type="submit" class="btn btn-success save_button">SAVE</button>
                <button type="button" class="btn btn-warning" data-dismiss="modal">CLOSE</button>
            </div>
        </form>
  </div><!-- /.modal-content -->
</div><!-- /.modal-dialog -->

resources/views/admin/marks/index.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <button type="button" class="btn btn-primary btn-modal" data-href="{{route('mark.create')}}" data-container=".modal_class">
              <i class="fa fa-plus"></i> ADD</button>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="{{url('admin')}}">HOME</a></li>
                <li class="breadcrumb-item active">MARKS</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            @include('admin.layouts.session')
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">MARKS</h3>
                </div>
                <div class="card-body">
                    <div id="example2_wrapper" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12">
                                <table class="table table-bordered table-striped data-table">
                                    <thead>
                                        <tr>
                                            <th>ID</th>
                                            <th>NAME</th>
                                            <th>TERM</th>
                                            @foreach ($subjects as $item)
                                                <th>{{$item->name}}</th>
                                            @endforeach
                                            <th>TOTAL</th>
                                            <th>DATE</th>
                                            <th>ACTION</th>
                                        </tr>
                                    </thead>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
<div class="modal fade modal_class" tabindex="-1" role="dialog" aria-labelledby="gridSystemModalLabel"></div>
@include('admin.layouts.footer')
<script >
    $( document ).ready(function() {
        var table = $('.data-table').DataTable({
        processing: true,
        serverSide: true,
        lengthMenu: [[25, 50, 100, 200, -1], [25, 50, 100, 200, "All"]],
        pageLength : 25,
        dom: "<'row'<'col-sm-2'l><'col-sm-7 text-center'B><'col-sm-3'f>><'row'<'col-sm-12'tr>><'row'<'col-sm-6'i><'col-sm-6'p>>",
        buttons: ["copy", "csv", "excel", "pdf", "print", "colvis"],
        ajax: {
          url: "{{ route('mark.index') }}",
          data: function (d) {
                d.search = $('input[type="search"]').val();
            }
        },
        columns: [
            {data: 'id', name: 'id'},
            {data: 'name', name: 'name'},
            {data: 'term', name: 'term'},
            @foreach($subjects as $item)
            { data: "{{$item->name}}", orderable: false },
            @endforeach
            {data: 'total', name: 'total'},
            {data: 'date', name: 'date'},
            {data: 'action', name: 'action'},
        ],
      });

      //for add
      $(document).unbind('submit').on('submit', 'form#createForm', function(e){
      e.preventDefault();
      $(this).find('button[type="submit"]').attr('disabled', true);
      var data = $(this).serialize();
      $.ajax({
          method: "post",
          url: $(this).attr("action"),
          dataType: "json",
          data: data,
          success:function(result){
              if(result.status == true){
                $('div.modal_class').modal('hide');
                  toastr.success(result.message);
                  $('.data-table').DataTable().ajax.reload();
              }else{
                    toastr.error(result.message);
                    $('.save_button').attr('disabled', false);
              }
          }
      });
    });

    //for edit function
    $(document).on('click', 'button.edit_button', function() {
        $('div.modal_class').load($(this).data('href'), function() {
            $(this).modal('show');
            $('form#edit_form').submit(function(e) {
                $(this).find('button[type="submit"]').attr('disabled', true);
                e.preventDefault();
                var data = $(this).serialize();

                $.ajax({
                    method: 'POST',
                    url: $(this).attr('action'),
                    dataType: 'json',
                    data: data,
                    success: function(result) {
                        if (result.status === true) {
                            $('div.modal_class').modal('hide');
                            toastr.success(result.message);
                            $('.data-table').DataTable().ajax.reload();
                        } else {
                            toastr.error(result.message);
                           $('.save_button').attr('disabled', false);
                        }
                    },
                });
            });
        });
    });
    });
    $("#userManagementNav").addClass('active');
    $("#userManagementNav").addClass('menu-open');
    $("#usersNav").addClass('active');
   </script>
   @include('admin.layouts.scripts')